/***************************************************************************
 *   Copyright (C) 2009 by QEVEN Team                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 **************************************************************************/

#ifndef VIDEO_MANAGERVIDEO_MANAGER_H
#define VIDEO_MANAGERVIDEO_MANAGER_H

#include <QList>
#include "video_analyzer.h"
#include "video_item.h"

namespace video_manager {

   using namespace video;
   using namespace utils;

   /**
    @author Roberto Ferrer Obregon, Yonnys Pablo Martin, Leonel Salazar <rferrer@uci.cu, ypmartin@uci.cu, leonelsv@uci.cu>
    */
   class Video_Manager
   {
        public:
      Video_Manager();
      Video_Manager( e_video_format format );
      ~Video_Manager();

      void add_Video( QString file );
      void add_Video( Video_Item* );
      void delete_Video( int pos );
      void set_Format( e_video_format new_format ); //permite establecer el formato
      void set_Format( QString format );
      Video_Item* get_Video( int pos ); //devuelve el video en una posicion
      int get_Length(); // devuelve la cant de items en la lista
      bool is_Empty(); //devuelve si la lista esta vacia o llena
      int get_Total_Size(); //devuelve el tamanno total ocupado por todos los archivos en el disco.
      QList<Video_Item*>* get_Video_List();
      QString format();
      QString toXML();
      e_video_format getFormat();
      void setProgramDir(QString);

      void change_Video_Settings ( int pos,
                                   QString vaspect,
                                   int vbitrate,
                                   int abitrate,
                                   bool has_subtitles,
                                   QString subtitle_file,
                                   QString subtitle_font,
                                   int subtitle_scale,
                                   int resolution,
                                   int width,
                                   int height) ; //modifica los valores de un video seleccionado en la lista
      void change_vopts_all(  int vbitrate,
                              int abitrate,
                              QString vaspect,
                              QString subtitle_font,
                              int subtitle_scale,
                              int resolution,
                              int width,
                              int height);

        private:
      QList<Video_Item*>* m_video_list;
      e_video_format m_format;
      QString MPlayer;
   };

}

#endif
